"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ElasticSearch = void 0;
var elastic_service_1 = require("./services/elastic.service");
var ElasticSearch = /** @class */ (function () {
    //constructor
    function ElasticSearch(config) {
        this.config = Object.assign(config);
        this.service = new elastic_service_1.ElasticSearchService(config.elasticUrl);
        this.elasticUrl = config.elasticUrl;
        this.index = config.index;
    }
    ElasticSearch.prototype.search = function (obj) {
        return __awaiter(this, void 0, void 0, function () {
            var result;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.service.search(this.index, obj)];
                    case 1:
                        result = _a.sent();
                        return [2 /*return*/, result];
                }
            });
        });
    };
    ElasticSearch.prototype.addItem = function (item) {
        return __awaiter(this, void 0, void 0, function () {
            var id;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.service.addItem(this.index, item)];
                    case 1:
                        id = _a.sent();
                        return [2 /*return*/, id];
                }
            });
        });
    };
    ElasticSearch.prototype.addMultipleItems = function (array) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.service.addMultipleItems(this.index, array)];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    ElasticSearch.prototype.searchByField = function (field, value) {
        return __awaiter(this, void 0, void 0, function () {
            var obj;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.service.searchByField(this.index, field, value)];
                    case 1:
                        obj = _a.sent();
                        return [2 /*return*/, obj];
                }
            });
        });
    };
    ElasticSearch.prototype.getByElasticId = function (id) {
        return __awaiter(this, void 0, void 0, function () {
            var ans;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.service.getByElasticId(this.index, id)];
                    case 1:
                        ans = _a.sent();
                        console.log('ans: ', ans);
                        return [2 /*return*/, ans[0]];
                }
            });
        });
    };
    ElasticSearch.prototype.deleteByElasticId = function (id) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                this.service.deleteDocumentByElasticId(this.index, id);
                return [2 /*return*/];
            });
        });
    };
    ElasticSearch.prototype.deleteByField = function (field, value) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                this.service.deleteByField(this.index, field, value);
                return [2 /*return*/];
            });
        });
    };
    ElasticSearch.prototype.deleteByMultipleFields = function (deleteObj) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                this.service.deleteByMultipleFields(this.index, deleteObj);
                return [2 /*return*/];
            });
        });
    };
    return ElasticSearch;
}());
exports.ElasticSearch = ElasticSearch;
//# sourceMappingURL=index.js.map