import { Configuration } from "./config";
import ElasticSearchInterface from "./ElasticSearchInterface";
import { ElasticSearchService } from "./services/elastic.service";

export class ElasticSearch implements ElasticSearchInterface<any> {
  //field
  config: Configuration;
  service: any;
  elasticUrl: string;
  index:string
  //constructor
  constructor(config: Configuration) {
    this.config = Object.assign(config);
    this.service = new ElasticSearchService(config.elasticUrl);
    this.elasticUrl = config.elasticUrl;
    this.index = config.index
  }
  async search(obj: any) {
    const result = await this.service.search(this.index, obj);
    return result;
  }
  async addItem(item: any) {
    const id = await this.service.addItem(this.index, item);
    return id;
  }
  async addMultipleItems(array: Array<any>) {
    return await this.service.addMultipleItems(this.index, array);
  }
  async searchByField(field:string,value: string) {
    const obj = await this.service.searchByField(this.index, field, value);
    return obj;
  }
  async getByElasticId(id: string) {
    const ans = await this.service.getByElasticId(this.index, id);
    console.log('ans: ',ans)
    return ans[0];
  }
  async deleteByElasticId(id: string) {
    this.service.deleteDocumentByElasticId(this.index, id);
  }
  async deleteByField(field: string, value: string) {
    this.service.deleteByField(this.index, field, value);
  }
  async deleteByMultipleFields(deleteObj: any) {
    this.service.deleteByMultipleFields(this.index, deleteObj);
  }
}
